%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  DATA FIELDS IN 'PROBDATA'  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Names of random variables. Default names are 'x1', 'x2', ..., if not explicitely defined.
% probdata.name =  { };

% Marginal distributions for each random variable
% probdata.marg =  [ (type) (mean) (stdv) (startpoint) (p1) (p2) (p3) (p4) (input_type); ... ];
% probdata.marg = [ 2      30       9      30  nan  nan  nan  nan 0 ; 
%                   2      20       8      20  nan  nan  nan  nan 0 ;
%                   2      16     6.4      16  nan  nan  nan  nan 0 ;
%                   1  454000   40000  454000  nan  nan  nan  nan 0 ;
%                   1  497000   40000  497000  nan  nan  nan  nan 0 ;
%                   1    0.94    0.12    0.94  nan  nan  nan  nan 0 ;
%                   1    1.33    0.15    1.33  nan  nan  nan  nan 0 ;
%                   1    2.47    0.30    2.47  nan  nan  nan  nan 0 ;
%                   1    3.00    0.35    3.00  nan  nan  nan  nan 0 ;
%                   1    1.25    0.30    1.25  nan  nan  nan  nan 0 ;
%                   1    1.63    0.40    1.63  nan  nan  nan  nan 0 ;
%                   1    2.69    0.65    2.69  nan  nan  nan  nan 0 ;
%                   1    3.00    0.75    3.00  nan  nan  nan  nan 0 ;
%                   1    3.36    0.60    3.36  nan  nan  nan  nan 0 ;
%                   1    4.00    0.80    4.00  nan  nan  nan  nan 0 ;
%                   1    5.44    1.00    5.44  nan  nan  nan  nan 0 ;
%                   1    6.00    1.20    6.00  nan  nan  nan  nan 0 ;
%                   1    2.72    1.00    2.72  nan  nan  nan  nan 0 ;
%                   1    3.13    1.10    3.13  nan  nan  nan  nan 0 ;
%                   1    4.01    1.30    4.01  nan  nan  nan  nan 0 ;
%                   1    4.50    1.50    4.50  nan  nan  nan  nan 0 ];
% 
% probdata.marg = [  2      30       9      30     nan     nan  nan  nan 0 ; 
%                    2      20       8      20     nan     nan  nan  nan 0 ;
%                    2      16     6.4      16     nan     nan  nan  nan 0 ;
%                   51     nan     nan  454000  454000   40000    0  inf 1 ;
%                   51     nan     nan  497000  497000   40000    0  inf 1 ;
%                   51     nan     nan    0.94    0.94    0.12    0  inf 1 ;
%                   51     nan     nan    1.33    1.33    0.15    0  inf 1 ;
%                   51     nan     nan    2.47    2.47    0.30    0  inf 1 ;
%                   51     nan     nan    3.00    3.00    0.35    0  inf 1 ;
%                   51     nan     nan    1.25    1.25    0.30    0  inf 1 ;
%                   51     nan     nan    1.63    1.63    0.40    0  inf 1 ;
%                   51     nan     nan    2.69    2.69    0.65    0  inf 1 ;
%                   51     nan     nan    3.00    3.00    0.75    0  inf 1 ;
%                   51     nan     nan    3.36    3.36    0.60    0  inf 1 ;
%                   51     nan     nan    4.00    4.00    0.80    0  inf 1 ;
%                   51     nan     nan    5.44    5.44    1.00    0  inf 1 ;
%                   51     nan     nan    6.00    6.00    1.20    0  inf 1 ;
%                   51     nan     nan    2.72    2.72    1.00    0  inf 1 ;
%                   51     nan     nan    3.13    3.13    1.10    0  inf 1 ;
%                   51     nan     nan    4.01    4.01    1.30    0  inf 1 ;
%                   51     nan     nan    4.50    4.50    1.50    0  inf 1 ];
                              
 % SI units               
kp = 1000*0.45359237*9.80665;
ke = 1000*0.45359237*9.80665/0.3048^2;
ki = 0.3048^4;
ka = 0.3048^2;
probdata.marg = [  2      30*kp       9*kp      30*kp     nan     nan  nan  nan 0 ; 
                   2      20*kp       8*kp      20*kp     nan     nan  nan  nan 0 ;
                   2      16*kp     6.4*kp      16*kp     nan     nan  nan  nan 0 ;
                  51     nan     nan  454000*ke  454000*ke   40000*ke    0  inf 1 ;
                  51     nan     nan  497000*ke  497000*ke   40000*ke    0  inf 1 ;
                  51     nan     nan    0.94*ki    0.94*ki    0.12*ki    0  inf 1 ;
                  51     nan     nan    1.33*ki    1.33*ki    0.15*ki    0  inf 1 ;
                  51     nan     nan    2.47*ki    2.47*ki    0.30*ki    0  inf 1 ;
                  51     nan     nan    3.00*ki    3.00*ki    0.35*ki    0  inf 1 ;
                  51     nan     nan    1.25*ki    1.25*ki    0.30*ki    0  inf 1 ;
                  51     nan     nan    1.63*ki    1.63*ki    0.40*ki    0  inf 1 ;
                  51     nan     nan    2.69*ki    2.69*ki    0.65*ki    0  inf 1 ;
                  51     nan     nan    3.00*ki    3.00*ki    0.75*ki    0  inf 1 ;
                  51     nan     nan    3.36*ka    3.36*ka    0.60*ka    0  inf 1 ;
                  51     nan     nan    4.00*ka    4.00*ka    0.80*ka    0  inf 1 ;
                  51     nan     nan    5.44*ka    5.44*ka    1.00*ka    0  inf 1 ;
                  51     nan     nan    6.00*ka    6.00*ka    1.20*ka    0  inf 1 ;
                  51     nan     nan    2.72*ka    2.72*ka    1.00*ka    0  inf 1 ;
                  51     nan     nan    3.13*ka    3.13*ka    1.10*ka    0  inf 1 ;
                  51     nan     nan    4.01*ka    4.01*ka    1.30*ka    0  inf 1 ;
                  51     nan     nan    4.50*ka    4.50*ka    1.50*ka    0  inf 1 ];

% Correlation matrix
probdata.correlation = eye(21);
probdata.correlation(4:5,4:5) = probdata.correlation(4:5,4:5) + 0.9*tril(ones(2,2),-1) + 0.9*triu(ones(2,2),1);
probdata.correlation(6:21,6:21) = probdata.correlation(6:21,6:21) + 0.13*tril(ones(16,16),-1) + 0.13*triu(ones(16,16),1);
probdata.correlation(6:21,6:21) = probdata.correlation(6:21,6:21) + (0.95-0.13)*(tril(ones(16,16),-8)-tril(ones(16,16),-9)) + (0.95-0.13)*(triu(ones(16,16),8)-triu(ones(16,16),9));

probdata.transf_type = 3;
probdata.Ro_method   = 1;
probdata.flag_sens   = 0;



                      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  DATA FIELDS IN 'ANALYSISOPT'  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

analysisopt.multi_proc           = 0;        % 1: block_size g-calls sent simultaneously
                                             %    - gfunbasic.m is used and a vectorized version of gfundata.expression is available.
                                             %      The number of g-calls sent simultaneously (block_size) depends on the memory
                                             %      available on the computer running FERUM.
                                             %    - gfunxxx.m user-specific g-function is used and able to handle block_size computations
                                             %      sent simultaneously, on a cluster of PCs or any other multiprocessor computer platform.
                                             % 0: g-calls sent sequentially
analysisopt.block_size           = 1;        % Number of g-calls to be sent simultaneously

% FORM analysis options
analysisopt.i_max                = 100;      % Maximum number of iterations allowed in the search algorithm
analysisopt.e1                   = 0.001;    % Tolerance on how close design point is to limit-state surface
analysisopt.e2                   = 0.001;    % Tolerance on how accurately the gradient points towards the origin
analysisopt.step_code            = 0;        % 0: step size by Armijo rule, otherwise: given value is the step size
analysisopt.Recorded_u           = 0;        % 0: u-vector not recorded at all iterations, 1: u-vector recorded at all iterations
analysisopt.Recorded_x           = 0;        % 0: x-vector not recorded at all iterations, 1: x-vector recorded at all iterations

% FORM, SORM analysis options
analysisopt.grad_flag            = 'ffd';    % 'ddm': direct differentiation, 'ffd': forward finite difference
analysisopt.ffdpara              = 1000;     % Parameter for computation of FFD estimates of gradients - Perturbation = stdv/analysisopt.ffdpara;
                                             % Recommended values: 1000 for basic limit-state functions, 50 for FE-based limit-state functions
analysisopt.ffdpara_thetag       = 1000;     % Parameter for computation of FFD estimates of dbeta_dthetag
                                             % perturbation = thetag/analysisopt.ffdpara_thetag if thetag ~= 0 or 1/analysisopt.ffdpara_thetag if thetag == 0;
                                             % Recommended values: 1000 for basic limit-state functions, 100 for FE-based limit-state functions

% Simulation analysis (MC,IS,DS,SS) and distribution analysis options
analysisopt.num_sim              = 500000;   % Number of samples (MC,IS), number of samples per subset step (SS) or number of directions (DS)
analysisopt.rand_generator       = 0;        % 0: default rand matlab function, 1: Mersenne Twister (to be preferred)

% Simulation analysis (MC, IS) and distribution analysis options
analysisopt.sim_point            = 'origin'; % 'dspt': design point, 'origin': origin in standard normal space (simulation analysis)
analysisopt.stdv_sim             = 1;        % Standard deviation of sampling distribution in simulation analysis

% Simulation analysis (MC, IS)
analysisopt.target_cov           = 0.01;     % Target coefficient of variation for failure probability
analysisopt.lowRAM               = 0;        % 1: memory savings allowed, 0: no memory savings allowed

% Directional Simulation (DS) analysis options
analysisopt.dir_flag             = 'random'; % 'det': deterministic points uniformly distributed on the unit hypersphere using eq_point_set.m function
                                             % 'random': random points uniformly distributed on the unit hypersphere
analysisopt.rho                  = 8;        % Max search radius in standard normal space for Directional Simulation analysis
analysisopt.tolx                 = 1e-5;     % Tolerance for searching zeros of g function
analysisopt.keep_a               = 0;        % Flag for storage of a-values which gives axes along which simulations are carried out
analysisopt.keep_r               = 0;        % Flag for storage of r-values for which g(r) = 0
analysisopt.sigmafun_write2file  = 0;        % Set to 0

% Subset Simulation (SS) analysis options
analysisopt.width                = 2;        % Width of the proposal uniform pdfs
analysisopt.pf_target            = 0.1;      % Target probability for each subset step
analysisopt.flag_cov_pf_bounds   = 1;        % 1: calculate upper and lower bounds of the coefficient of variation of pf, 0: no calculation 
analysisopt.ss_restart_from_step = -inf;     % i>=0 : restart from step i, -inf : all steps, no record (default), -1 : all steps, record all
analysisopt.flag_plot            = 0;        % 1: plots at each step (2 r.v. examples only), 0: no plots
analysisopt.flag_plot_gen        = 0;        % 1: intermediate plots for each MCMC chain (2 r.v. examples only), 0: no plots

% 2SMART analysis options
analysisopt.num_sim_sdu          = [ 50 50 ];         % Nu number of points ( [ first subset-like step, next steps], same values by default )
analysisopt.num_sim_norm         = [ 100 100 ];       % Nn number of points ( [ first subset-like step, next steps], same values by default )
nrv = size(probdata.marg,1);
analysisopt.buf_size             = round(1.25e7/nrv); % RAM-size dependent parameter (important for large number of random variables)
analysisopt.svm_buf_size         = 3500^2;            % RAM-size dependent parameter for eval_svm.m function
analysisopt.flag_var_rbf         = 0;                 % 0: cross validation at the 1st subset-like step only, 1: cross validation at all steps

% Global Sensitivity Analysis (GSA) analysis options
analysisopt.sampling             = 1;        % sampling = 1: Sobol' indices are assessed from Crude Monte Carlo (CMC) simulations
                                             %            2: Sobol' indices are assessed from Quasi Monte Carlo (QMC) simulations 
analysisopt.Sobolsetopt          = 0;        % Sobolsetopt = 0: Sobol' sequences from Matlab Statistic toolbox
                                             %               1: Sobol' sequences from Sobol' ( Broda - http://www.broda.co.uk/ )
analysisopt.first_indices        = 1;        % first_indices = 1: assessment of first order indices
                                             %                 0: no assessment
analysisopt.total_indices        = 1;        % total_indices = 1: assessment of total indices
                                             %                 0: no assessment
analysisopt.all_indices          = 0;        % all_indices = 1: assessment of first order, second order,..., all order indices (analysisopt.first_indices must be set to 1)
                                             %               0: no assessment
analysisopt.NbCal                = 1;        % Number of replications of Sobols' indices assessments (based on the same SVR surrogate, if analysisopt.SVR = 'yes') 
                                             %    NbCal = 1: one single assessment
                                             %    NbCal > 1: assessment of mean and variance for each Sobols'indice




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  DATA FIELDS IN 'GFUNDATA' (one structure per gfun)  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Type of limit-state function evaluator:
% 'basic': the limit-state function is defined by means of an analytical expression or a Matlab m-function,
%          using gfundata(lsf).expression. The function gfun.m calls gfunbasic.m, which evaluates gfundata(lsf).expression.
% 'xxx':   the limit-state function evaluation requires a call to an external code.  The function gfun.m calls gfunxxx.m,
%          which evaluates gfundata(lsf).expression where gext variable is a result of the external code.
gfundata(1).evaluator  = '_ex5';

% Expression of the limit-state function:
% gfundata(1).expression = '';

% cg deterministic parameters of the limit-state function (optional, may also be defined in probdata.marg)
% gfundata(1).cg = [ (cg1) (cg2) ... ]
%               or [ (cg1) (cg2) ... ]'

gfundata(1).cg         = [ 0.2 1 ];
gfundata(1).cg         = [ 0.2*0.3048 0.3048 ]; % SI units

gfundata(1).cg         = [ 0.07 0.3048 ]; % SI units, Pf ref = 

% Names of cg parameters (cg1, cg2, ... if not defined):
% gfundata(1).cgname = {'name1' 'name2' ... }
%                   or {'name1' 'name2' ... }'
gfundata(1).cgname     = { 'u1max' 'kl' };

% Flag for computation of sensitivities w.r.t. thetag parameters of the limit-state function
% 1: all sensitivities assessed, 0: no sensitivities assessment
gfundata(1).flag_sens  = 0;




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  DATA FIELDS IN 'FEMODEL'  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

femodel = [];




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  DATA FIELDS IN 'RANDOMFIELD'  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

randomfield = [];
